田草博客

互联网田草博客


网友交流QQ群:11740834 需注明申请加入原因

微信 公众号:ByCAD

邮箱:tiancao1001x126.com
ByCAD,微信公众号
首页 | 普通 | 电脑 | AutoCAD | VB/VB.NET | FLash | 结构 | 建筑 | 电影 | BIM | 规范 | 软件 | ID
-随机-|-分布-
-博客论坛-|-﨣﨤﨧﨨-
-网站导航-|-规范下载-
-BelovedFLash欣赏-

用户登陆
用户:
密码:
 

站点日历
73 2024 - 3 48
     12
3456789
10111213141516
17181920212223
24252627282930
31


站点统计

最新评论



vb.net 触发Button的click事件 隐藏日志,无权浏览
未知 MemberInfo查询DBObject的属性和方法   [ 日期:2019-01-27 ]   [ 来自:本站原创 ]  HTML
using System.Reflection;
using Autodesk.AutoCAD.Runtime;
using Autodesk.AutoCAD.ApplicationServices;
using Autodesk.AutoCAD.DatabaseServices;
using Autodesk.AutoCAD.EditorInput;
using Exception = System.Exception;

[assembly: CommandClass(typeof(AutoCAD_CSharp_plug_in35.MyCommands))]

namespace AutoCAD_CSharp_plug_in35
{
    public class MyCommands
    {
        [LispFunction("test", "MyLispFunctionLocal")]
        public void MyLispFunction(ResultBuffer args) // This method can have any name
        {
            if (args != null)
            {
                TypedValue[] values = args.AsArray();
                if (values .Length == 1 && values[0].TypeCode == (int)LispDataType .ObjectId )
                {
                    Document doc = Application.DocumentManager.MdiActiveDocument;
                    Editor ed = doc.Editor;
                    Database db = doc.Database;
                    Transaction tr = db.TransactionManager.StartTransaction();
                    using (tr)
                    {
                        try
                        {
                            var id =(ObjectId ) values[0].Value;
                            var obj = (DBObject) id.GetObject(OpenMode.ForRead);
                            foreach (MemberInfo objMemberInfo in obj.GetType().GetMembers())
                            {
                                ed.WriteMessage("\n" + objMemberInfo.Name.ToString());
                            }
                            tr.Commit();
                        }
                        catch (Exception)
                        {
                            throw;
                        }
                    }
                }
            }
        }
    }
}

http://bbs.xdcad.net/thread-679007-1-1.html


    <CommandMethod("Tctype1", CommandFlags.Modal)> _
    Public Sub MyLispFunction()
        ' This method can have any name
        Dim dwg As Document = Application.DocumentManager.MdiActiveDocument
        Dim result As PromptEntityResult = dwg.Editor.GetEntity(vbLf & "Select entity: ")

        Dim doc As Document = Application.DocumentManager.MdiActiveDocument
        Dim ed As Editor = doc.Editor
        Dim db As Database = doc.Database
        Dim tr As Transaction = db.TransactionManager.StartTransaction()
        Using tr
            Try
                Dim id As ObjectId = CType(result.ObjectId, ObjectId)
                Dim obj As DBObject = CType(id.GetObject(OpenMode.ForRead), DBObject)
                For Each objMemberInfo As MemberInfo In obj.[GetType]().GetMembers()
                    ed.WriteMessage(vbLf + objMemberInfo.Name.ToString())
                Next
                tr.Commit()
            Catch generatedExceptionName As Exception
                Throw
            End Try
        End Using
    End Sub

[本日志由 tiancao1001 于 2019-08-14 02:37 PM 编辑]


暂时没有评论
发表评论 - 不要忘了输入验证码哦!
作者: 用户:  密码:   注册? 验证:  防止恶意留言请输入问题答案:1*4=?  
评论:

禁止表情
禁止UBB
禁止图片
识别链接
识别关键字

字体样式 文字大小 文字颜色
插入粗体文本 插入斜体文本 插入下划线
左对齐 居中对齐 右对齐
插入超级链接 插入邮件地址 插入图像
插入 Flash 插入代码 插入引用
插入列表 插入音频文件 插入视频文件
插入缩进符合
点击下载按钮 下标 上标
水平线 简介分割标记
表  情
 
Tiancao Blog All Rights Reserved 田草博客 版权所有
Copyright ©